REM - CRYPTO45 - ROTORS MATCHING ANALYSIS                        (21 AUG 95)

'                SEE ALSO C/18.
'                FOR REGULAR ROTORS (ROTORS.DAT) ANALYSIS

CLS

  DIM E$(6)
  DIM G(100)
  DIM J(10)
  DIM R(100)
  DIM R$(100)

  CLS
  LOCATE 4, 14
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "Welcome to the CRYPTO45 - ROTORS MATCHING ANALYSIS"
  COLOR 7, 0                          'WHITE/BLACK
  LOCATE 6, 18
  PRINT "Place the disk having ROTORS.DAT Drive B"
  COLOR 12, 0                         'RED/BLACK
  LOCATE 20, 5
  PRINT TAB(26); "By  Clarence E. Tyner Jr."
  LOCATE 21, 5
  PRINT TAB(15); "Copyright 1995  - All Rights Reserved Worldwide"
  COLOR 7, 0


  LOCATE 15, 17

  INPUT "ENTER THE HIT NUMBER CLASS (1,2,3..6, ETC.)  ", D
 
  TYPE ROTORSET
     ROTOR AS STRING * 200
  END TYPE

  DIM ROTORS AS ROTORSET

  OPEN "B:ROTORS.DAT" FOR RANDOM AS #1 LEN = 200


  FOR X = 1 TO 100
    GOSUB TAB2Y
    R$(X) = ROTORS.ROTOR
  NEXT X

  J = 1
  FOR Y = 1 TO 100
    FOR Z = J TO 100
      IF Z = Y THEN GOTO TAB1
      C = 0
      FOR I = 1 TO 6: E$(I) = " ": NEXT I: F = 0
      FOR V = 1 TO 200 STEP 2
        E$ = MID$(R$(Y), V, 2)
        F$ = MID$(R$(Z), V, 2)
        IF E$ = F$ THEN
          F = F + 1
          E$(F) = E$
          C = C + 1
          END IF
      NEXT V

      IF C = 0 THEN GOTO TAB1
      IF C <> D THEN GOTO SKIP
      IF Y <> Y1 THEN
        PRINT                         'SPACE BETWEEN ROTORS
        K = K + 1
        END IF

        PRINT USING "No. ####   ROTOR  ##  vs  ROTOR ###  =  ##   "; L + 1; Y; Z; C;
        PRINT USING "Matches are  \\  \\  \\  \\  \\  \\"; E$(1); E$(2); E$(3); E$(4); E$(5); E$(6)
        Y1 = Y
        K = K + 1
        L = L + 1                     'TALLY OF C VALUES
        R(Y) = R(Y) + 1
        R(Z) = R(Z) + 1
        G(VAL(E$(1))) = G(VAL(E$(1))) + 1
        IF D < 2 GOTO SKIP
        G(VAL(E$(2))) = G(VAL(E$(2))) + 1
        IF D < 3 GOTO SKIP
        G(VAL(E$(3))) = G(VAL(E$(3))) + 1
        IF D < 4 GOTO SKIP
        G(VAL(E$(4))) = G(VAL(E$(4))) + 1
        IF D < 5 GOTO SKIP
        G(VAL(E$(5))) = G(VAL(E$(5))) + 1
        IF D < 6 GOTO SKIP
        G(VAL(E$(6))) = G(VAL(E$(6))) + 1
SKIP:

    IF K >= 21 THEN
       PRINT "PRESS <enter> TO CONTINUE"
       SLEEP
       K = 0
       END IF
 
TAB1:
    NEXT Z
    J = J + 1
  NEXT Y
PRINT "TOTAL CATEGORY "; D; " MATCHES = "; L; "    Press <enter> to continue"

SLEEP
    PRINT "               BY CONTACTS WITHIN ROTORS           Press <enter> to continue"
    PRINT "         1   2   3   4   5   6   7   8   9   0"
    COLOR 14, 0
    PRINT "     --|---|---|---|---|---|---|---|---|---|---|"
    COLOR 7, 0
    FOR H1 = 1 TO 10
    COLOR 14, 0
    PRINT USING "     # |"; H1 - 1;
    COLOR 7, 0
      FOR H2 = 1 TO 10
        H3 = H3 + 1
        IF G(H3) = 0 THEN
           COLOR 14, 0
           PRINT USING "\\ |"; "";
           COLOR 7, 0
           GOTO SKIP2
           END IF
        J(H1) = J(H1) + G(H3)
        COLOR 14, 0
        PRINT USING "\\ |"; STR$(G(H3));
        COLOR 7, 0
SKIP2:
      NEXT H2

      COLOR 10, 0                     'GREEN/BLACK
      PRINT USING "  ##"; J(H1);
      COLOR 14, 0                     'YELLOW/BLACK
      PRINT : PRINT "     --|---|---|---|---|---|---|---|---|---|---|"
      COLOR 7, 0
    NEXT H1
    SLEEP
  
    PRINT "                     BY ROTORS                  Press <enter> to continue"
    PRINT "         1   2   3   4   5   6   7   8   9   0"
    COLOR 14, 0
    PRINT "     --|---|---|---|---|---|---|---|---|---|---|"
    COLOR 7, 0
    FOR H1 = 1 TO 10
    COLOR 14, 0
    PRINT USING "     # |"; H1 - 1;
    COLOR 7, 0
      FOR H2 = 1 TO 10
        H4 = H4 + 1
        IF R(H4) = 0 THEN
           COLOR 14, 0
           PRINT USING "\\ |"; "";
           COLOR 7, 0
           GOTO SKIP3
           END IF
       
        S(H1) = S(H1) + R(H4)
        COLOR 14, 0
        PRINT USING "\\ |"; STR$(R(H4));
        COLOR 7, 0
SKIP3:
      NEXT H2
      PRINT USING "  ##"; S(H1);
      COLOR 14, 0
      PRINT : PRINT "     --|---|---|---|---|---|---|---|---|---|---|"
      COLOR 7, 0
    NEXT H1
    SLEEP
END

       
TAB2Y:  '-----------------------ROUTINE TO READ ROTORS FROM FILE

  CLS

  NUM.RECS = LOF(1) / 200

START:

    ROTORNUM = X
    GET #1, ROTORNUM, ROTORS

RETURN

    Y3 = 0
    U5 = 1
    FOR X9 = 1 TO 4
      PRINT USING "\   \"; "From ";
      FOR Y7 = 1 TO 25
        PRINT USING "###"; Y3 + Y7;
      NEXT Y7
      PRINT
      Y3 = Y3 + 25

      GOSUB TABZ
      PRINT USING "\   \"; "To   ";
      FOR U = 1 TO 25
        PRINT USING " \\"; MID$(ROTORS.ROTOR, U5, 2);
        U5 = U5 + 2
      NEXT U
      PRINT : PRINT : PRINT
    NEXT X9

    PRINT

  GOTO START                          'TO MAIN MENU

TABZ:
  PRINT USING "\   \"; "     ";
  COLOR 14, 0                         'YELLOW/BLACK
  FOR Z = 1 TO 25
  PRINT USING " \\"; "--";
  NEXT Z
  COLOR 7, 0                          'WHITE/BLACK
  PRINT
  RETURN

