REM - CRYPTO43 - ENIGMA95 CIPHER MACHINE DATA PATHS DEMONSTRATOR  (3 AUG 95)
REM $DYNAMIC
CLEAR

'              THIS PROGRAM IS USED - ONLY - TO PRINT THE ACTION OF THE
'              CHARACTER SET, ROTORS AND PLUGBOARD FOR A DEMONSTRATION
'              BY TRACING THE PATH OF THE INPUT TO THE OUTPUT.....ONE
'              INPUT AT A TIME.  IT IS NOT MEANT TO PROCESS AN ENTIRE
'              MESSAGE.

CLS
DIM A(12)                             'ROTORS DESIGNATOR ARRAY
DIM A$(12)                            'ROTORS ORIENTATION ARRAY
DIM C(100)                            'SUPER ENCIPHERMENT COL. COUNTER
DIM C1(100)                           'SUPER ENCIPHERMENT COUNTER HOLDER
DIM C4(27)                            'COLUMNS TALLY - FOR GARBLES CHECK
DIM C$(100)                           'CODE NUMBER ARRAY
DIM D(100)                            'CODE OUTPUT COUNTER
DIM E1(100)                           'PLUGBOARD INPUT EDITOR
DIM F$(100, 8)                        'ALPHA SUPERENCIPHERING ARRAY
DIM G(26, 26)                         'SUPERENCIPHERMENT OUTPUT ANALYSIS
DIM G5(26, 26)                        'SUPERENCIPHERMENT OUTPUT ANALYSIS
DIM H(26)                             'SUPERENCIPHERMENT COLUMN COUNTER
DIM I3(100)                           'INPUT COUNTER
DIM O(100)                            'OUTPUT COUNTER
DIM P(24)                             'PRIME NUMBERS
DIM PB$(50)                           'PLUGBOARD CONNECTIONS
DIM R4(100)                           'ROWS TALLY - FOR GARBLES CHECK
DIM R5(100)                           'ROWS TALLY - BACKUP
DIM RB$(12)                           'BOTTOM OF SCREEN ROTOR DISPLAY
DIM S(13)                             'ROTOR ROTATION VALUE CHECK
DIM T(13)                             'INITIAL ROTOR SETTINGS
'--------------------far heap memory----------------------------------
DM1% = 1
DM12% = 12
DM26% = 26

DIM I(DM1%) AS STRING * 324           'SCREENFUL OF DATA - CIPHER
DIM I4(DM12%) AS STRING * 324         'OUTPUT HOLDING ARRAY
DIM J(DM26%, DM26%) AS STRING * 2     'ALPHA SUPER DECIPHERING ARRAY
DIM K(DM1%) AS STRING * 324           'SCREENFUL OF DATA - CLEARTEXT
DIM N(DM1%) AS STRING * 1600          'DIMENSION DISK ENCIPHER TABLE 1
DIM P0(DM12%) AS STRING * 200         'POSITION FACES OF ROTORS
DIM R(DM12%) AS STRING * 200          'ROTOR SET SELECTED
DIM R1(DM12%) AS STRING * 200
DIM R1A(DM12%) AS STRING * 200

I(1) = STRING$(324, "  ")
K(1) = STRING$(324, "  ")

'---------------------------------------------------------------------

B$ = "01020304050607080910111213141516171819202122232425"
C$ = "26272829303132333435363738394041424344454647484950"
D$ = "51525354555657585960616263646566676869707172737475"
E$ = "76777879808182838485868788899091929394959697989900"

P0$ = B$ + C$ + D$ + E$               'MASTER ROTOR FRONT
PR$ = P0$                             'FRONT OF REVERSING ROTOR
CC$ = P0$                             'RANDOM STARTING POSITION SELECTOR
B$ = "": C$ = "": D$ = "": E$ = ""
Z1$ = P0$                             'PART 1 OF PLUGBOARD
Z2$ = P0$                             'PART 2 OF PLUGBOARD

FOR E = 1 TO 32: PB$(E) = "    ": NEXT E  'INITIALIZE PLUGBOARD

M10$ = CHR$(186)                      '

TAB01:  '----------------------------- START OF PROGRAM

 CLS
 LOCATE 4, 20
 COLOR 14, 0                          'YELLOW/BLACK
 PRINT "       THIS PROGRAM ONLY PRINTS DATA PATHS THROUGH THE CHARACTER SET,"
 PRINT "      PLUGBOARD AND ROTORS TO HARDCOPY ILLUSTRATE THE PROCESSING FLOW"
 PRINT
 PRINT " YOU MUST HAVE A";
 COLOR 27, 0
 PRINT "  WIDE CARRIAGE ";
 COLOR 14, 0
 PRINT " PRINTER AND ";
 COLOR 27, 0
 PRINT " 14 INCH WIDE ";
 COLOR 14, 0
 PRINT " PAPER TO PRINT"
 COLOR 7, 0                           'WHITE/BLACK

  LOCATE 15, 15
  PRINT "DO YOU WANT TO (1) ENCIPHER OR (2) DECIPHER ?"
REPEAT01: Q$ = INKEY$: IF Q$ = "" THEN GOTO REPEAT01
  IF Q$ <> "1" AND Q$ <> "2" THEN GOTO TAB01
  CLS
 
  LOCATE 10, 20
  PRINT "INSERT ";
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "ROTORS DISK ";
  COLOR 7, 0                          'WHITE/BLACK
  BEEP: BEEP
  INPUT "THEN PRESS ENTER", O
  
  CLS

  M1$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 .,:;'=!@#$%&*"
  M2$ = "abcdefghijklmnopqrstuvwxyz_-+/?(){}<>[]~~~~~~~~~~~"
  M3$ = M1$ + M2$
  M1$ = "": M2$ = ""

  LPRINT CHR$(27); "@";               'INITIALIZE PRINTER
  LPRINT CHR$(27); "5"                'DESELECT ITALIC PRINTING
  LPRINT CHR$(27); "t"; "1"           'SELECT GRAPHIC CHARACTER SET
  LPRINT CHR$(27); "6";               'SELECT GRAPHIC CHARACTER SET 2
  LPRINT CHR$(27); "g";               '15 CPI PITCH
  LPRINT CHR$(27); "k"; CHR$(1);      'SANS SERIF FONT
  LPRINT CHR$(27); "E";               'BOLD FONT
  WIDTH LPRINT 205                    'SET LINE WIDTH TO 205 COLUMNS
  LPRINT CHR$(27); "Q"; CHR$(205);    '205 CHARACTERS PER LINE
  
  Q = 1                            'FILL CODE NUMBER ARRAY WITH 2-DIGIT CODES
  FOR X = 1 TO 100
    C$(X) = MID$(P0$, Q, 2)
    Q = Q + 2
  NEXT X

  CLS

  GOSUB TAB59  '---------------------- SET PLUGBOARD

  CLS

REPEAT02:  '-------------------------- CREATE ROTORS

  LOCATE 11, 10
  INPUT "S.O.I. : ENTER NUMBER OF ROTORS TO BE USED (1 TO 12) :  ", N
  IF N > 12 THEN
    BEEP
    GOTO REPEAT02
    END IF
  IF N <= 0 THEN
    BEEP
    GOTO REPEAT02
    END IF
  PRINT

  CLS
  LOCATE 2, 20
  PRINT N; " ROTORS ARE TO BE SELECTED FROM THE S.O.I."
  CHECKSUM1 = CHECKSUM1 + N

  LOCATE 4, 5
  PRINT "   Select Rotor (1 to 100) and Orientation (1 or 2) ";
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT "IN THE SAME ENTRY :"
  COLOR 7, 0                          'WHITE/BLACK
  PRINT
  PRINT TAB(15); "For example : < RO >  or  < RRO >  or  < RRRO >  <enter>"
  PRINT TAB(15); "              < 71 >      < 232 >      < 1001 >"
  PRINT
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT TAB(43); "ROTOR   ORIENTATION"
  LOCATE 24, 1
  PRINT "To correct a PRIOR entry, input ' * ' < enter >"
  FOR X = 1 TO N

REPEAT03:

  LOCATE 9 + X, 21
  COLOR 14, 0                         'YELLOW/BLACK
 
  PRINT ; "   Position No. "; X;
  INPUT ; "    ", X$
  X10 = LEN(X$)

  IF X$ = "*" THEN                    'TO CORRECT PRIOR ENTRY
     X = X - 1
     PRINT STRING$(80, " ")
     GOTO REPEAT03
     END IF

  SELECT CASE X10
    CASE 2
      A(X) = VAL(MID$(X$, 1, 1))      'ROTORS 1 -9
    CASE 3
      A(X) = VAL(MID$(X$, 1, 2))      'ROTORS 10 - 99
    CASE 4
      A(X) = VAL(MID$(X$, 1, 3))      'ROTOR 100
  END SELECT

  A$(X) = RIGHT$(X$, 1)
  IF A(X) > 100 OR A(X) < 1 THEN
    BEEP
    LOCATE 11 + X, 1
    PRINT STRING$(80, " ")
    GOTO REPEAT03
    END IF

    FOR J5 = 1 TO X
      IF X = J5 THEN EXIT FOR
      IF A(X) = A(J5) THEN
        BEEP
        GOTO REPEAT03
        END IF
    NEXT J5

  LOCATE 10 + X, 55
  COLOR 14, 0                         'RED/BLACK
  IF A$(X) <> "1" AND A$(X) <> "2" THEN
    BEEP
    LOCATE 9 + X, 1
    PRINT STRING$(33, " ")
    GOTO REPEAT03
    END IF

  A(X) = VAL(MID$(X$, 1, X10 - 1))    'ROTOR No.
  A$(X) = RIGHT$(X$, 1)               'ORIENTATION
  LOCATE 10 + (X - 1), 1
  PRINT STRING$(80, " ")
  LOCATE 10 + (X - 1), 24
 
  IF A$(X) = "1" THEN
     COLOR 2, 0
     PRINT USING "Position No. ##     ###    \\- "; X; A(X); A$(X);
     PRINT "Forward"
  ELSE
     COLOR 12, 0
     PRINT USING "Position No. ##     ###    \\- "; X; A(X); A$(X);
     PRINT "Backward"
  END IF

  COLOR 14, 0
  LOCATE 10 + X, 1
  PRINT STRING$(80, " ")
  CHECKSUM1 = CHECKSUM1 + A(X) + VAL(A$(X))
  NEXT X

  LOCATE 23, 1
  PRINT STRING$(80, " ")
  LOCATE 10 + X, 1

  COLOR 7, 0                          'WHITE/BLACK

TAB03:    ' -------------------------- START A NEW MESSAGE

  F1 = FRE("")
  IF F5 = 1 THEN                      'TO RESTART SCREEN
    GOSUB TAB107                      'RESTORE ROTORS
    GOTO TAB09
  END IF

  G3 = 0
  G4 = 0
  K1 = 0
  X6 = 0
  X8 = 0
  X9 = 0
  R = 0

  FOR X = 1 TO 27: C4(X) = 0: NEXT X  'COLUMN TALLY

  FOR X = 1 TO 26
    FOR Y = 1 TO 26
      G(X, Y) = 0                     'INITIALIZE SE ANALYSIS COUNTER
    NEXT Y
  NEXT X

  W5 = 0                              'INITIALIZE PRINT SWITCH
  HC = 0                              'INITIALIZE HASH COUNT
  PR$ = P0$                           'FRONT OF REVERSING ROTOR

  FOR X = 0 TO 100                    'INITIALIZE
    R4(X) = 0                         'ROW TALLY
    O(X) = 0                          'INPUT/OUTPUT COUNTER
    C(X) = 1                          'SUPER ENCIPHERMENT COUNTER
  NEXT X

  IF ANOTHER$ = "Y" THEN M = 0        'INITIALIZE SETTINGS PRINTING

  GOSUB TAB74                         'LOAD ROTORS FROM DISK

  FOR X = 1 TO N                      'PUT ROTORS IN CORRECT ORDER
                                      
    SELECT CASE X
      CASE 1
         R1(1) = R(X)
         P0(1) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(1), P0(1)
            END IF

      CASE 2
         R1(2) = R(X)
         P0(2) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(2), P0(2)
            END IF

      CASE 3
         R1(3) = R(X)
         P0(3) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(3), P0(3)
            END IF

      CASE 4
         R1(4) = R(X)
         P0(4) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(4), P0(4)
            END IF

      CASE 5
         R1(5) = R(X)
         P0(5) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(5), P0(5)
            END IF

      CASE 6
         R1(6) = R(X)
         P0(6) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(6), P0(6)
            END IF

      CASE 7
         R1(7) = R(X)
         P0(7) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(7), P0(7)
            END IF

      CASE 8
         R1(8) = R(X)
         P0(8) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(8), P0(8)
            END IF

      CASE 9
         R1(9) = R(X)
         P0(9) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(9), P0(9)
            END IF

      CASE 10
         R1(10) = R(X)
         P0(10) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(10), P0(10)
            END IF

      CASE 11
         R1(11) = R(X)
         P0(11) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(11), P0(11)
            END IF

      CASE 12
         R1(12) = R(X)
         P0(12) = P0$
         IF A$(X) = "2" THEN
            SWAP R1(12), P0(12)
            END IF
        
    END SELECT

  NEXT X

  GOSUB TAB93                         'GET REVERSING ROTOR FROM DISK

  FOR C5 = 1 TO 200                   'FILL SPACES WITH ZEROS
    IF MID$(A6$, C5, 1) = " " THEN MID$(A6$, C5, 1) = "0"
  NEXT C5

  RR$ = A6$

  IF CORR$ = "Y" THEN GOTO TAB05      'CORRECTION OF CURRENT MESSAGE

  CLS
  LOCATE 1, 10
  PRINT "      (See the current S.O.I for the values to use)"
  LOCATE 3, 10
  PRINT "        SET ROTATIONAL SHIFT VALUES FOR EACH ROTOR"
  LOCATE 5, 10
  PRINT "        POSITION USING THE FOLLOWING PRIME NUMBERS"
  LOCATE 8, 5
  PRINT "0,1,3,7,11,13,17,19,23,29,31,37,41,";
  PRINT "43,47,53,59,61,67,71,73,79,83,89,97"
  PRINT
 
  DATA 1,3,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97
  FOR PN = 1 TO 24
    READ P(PN)
  NEXT PN

  COLOR 14, 0                         'YELLOW/BLACK
  FOR X = 1 TO N
    SELECT CASE X
          CASE 1
REDO01:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 1   :   ", S1
            S(X) = S1
              P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S1 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO01
              END IF
            S1A = 200 - (S1 * 2)

         CASE 2
REDO02:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 2   :   ", S2

            S(X) = S2
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S2 = S(J6) THEN
                BEEP
                GOTO REDO02:
                EXIT FOR
                END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S2 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO02
              END IF
              S2A = 200 - (S2 * 2)

         CASE 3
REDO03:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 3   :   ", S3

            S(X) = S3
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S3 = S(J6) THEN
                BEEP
                GOTO REDO03
                EXIT FOR
                END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S3 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO03
              END IF
              S3A = 200 - (S3 * 2)

         CASE 4
REDO04:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 4   :   ", S4

            S(X) = S4
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S4 = S(J6) THEN
                BEEP
                GOTO REDO04
                EXIT FOR
                END IF
            NEXT J6

            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S4 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO04
              END IF
              S4A = 200 - (S4 * 2)

         CASE 5
REDO05:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 5   :   ", S5

            S(X) = S5
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S5 = S(J6) THEN
                BEEP
                GOTO REDO05
                EXIT FOR
                END IF
            NEXT J6


            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S5 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO05
              END IF
              S5A = 200 - (S5 * 2)

         CASE 6
REDO06:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 6   :   ", S6

            S(X) = S6
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S6 = S(J6) THEN
                BEEP
                GOTO REDO06
                EXIT FOR
                END IF
            NEXT J6


            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S6 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO06
              END IF
              S6A = 200 - (S6 * 2)

         CASE 7
REDO07:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 7   :   ", S7

            S(X) = S7
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S7 = S(J6) THEN
                BEEP
                GOTO REDO07
                EXIT FOR
                END IF
            NEXT J6


            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S7 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO07
              END IF
              S7A = 200 - (S7 * 2)

         CASE 8
REDO08:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 8   :   ", S8

            S(X) = S8
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S8 = S(J6) THEN
                BEEP
                GOTO REDO08
                EXIT FOR
                END IF
            NEXT J6


            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S8 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO08
              END IF
              S8A = 200 - (S8 * 2)

         CASE 9
REDO09:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 9   :   ", S9

            S(X) = S9
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S9 = S(J6) THEN
                BEEP
                GOTO REDO09
                EXIT FOR
                END IF
            NEXT J6


            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S9 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO09
              END IF
              S9A = 200 - (S9 * 2)

         CASE 10
REDO10:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 10  :   ", S10

            S(X) = S10
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S10 = S(J6) THEN
                BEEP
                GOTO REDO10
                EXIT FOR
                END IF
            NEXT J6


            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S10 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO10
              END IF
              S10A = 200 - (S10 * 2)

         CASE 11
REDO11:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 11  :   ", S11

            S(X) = S11
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S11 = S(J6) THEN
                BEEP
                GOTO REDO11
                EXIT FOR
                END IF
            NEXT J6


            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S11 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO11
              END IF
              S11A = 200 - (S11 * 2)

         CASE 12
REDO12:
            LOCATE 11 + X, 25
            INPUT "FOR ROTOR POSITION 12  :   ", S12

            S(X) = S12
            FOR J6 = 1 TO X
              IF J6 = X THEN EXIT FOR
              IF S12 = S(J6) THEN
                BEEP
                GOTO REDO12
                EXIT FOR
                END IF
            NEXT J6


            P2 = 0
            FOR PN = 0 TO 24
              IF P(PN) = S12 THEN
              P2 = 1
              EXIT FOR
              END IF
            NEXT PN

            IF P2 = 0 THEN
              BEEP
              GOTO REDO12
              END IF
              S12A = 200 - (S12 * 2)

         END SELECT

  NEXT X

REDO13:
  COLOR 10, 0                         'GREEN/BLACK
  LOCATE 11 + X + 1, 25
  INPUT "FOR REVERSING ROTOR    :   ", SR

            S(13) = SR
            FOR J6 = 1 TO 13
              IF J6 = 13 THEN EXIT FOR
              IF SR = S(J6) THEN
                BEEP
                GOTO REDO13
                EXIT FOR
                END IF
            NEXT J6


  P2 = 0
  FOR PN = 0 TO 24
    IF P(PN) = SR THEN
      P2 = 1
      EXIT FOR
      END IF
  NEXT PN

  IF P2 = 0 THEN
     BEEP
     GOTO REDO13
     END IF
  SRA = 200 - (SR * 2)
  COLOR 7, 0                          'WHITE/BLACK

  CHECKSUM1 = CHECKSUM1 + S1 + S2 + S3 + S4 + S5 + S6 + S7
  CHECKSUM1 = CHECKSUM1 + S8 + S9 + S10 + S11 + S12 + SR


TAB04:   '---------------------------- INITIAL SETTINGS ROUTINE

  GOSUB TAB96                         'GET BASE CHARACTER SET
  Y1 = INSTR(Y4$, " ")                'LOCATE BLANK SPACE
  Y1$ = STR$(Y1)                      'ASSIGN VALUE TO SPACE

  CLS
  PRINT "Internal Checksum = "; CHECKSUM1
  LOCATE 8, 22
  PRINT "           (See your list)"
  LOCATE 10, 22
  PRINT "SET INITIAL ROTOR SETTINGS (1 TO 100)"
  PRINT

  COLOR 14, 0                         'YELLOW/BLACK
  FOR X = 1 TO N
REENTER1:
    LOCATE 11 + X, 20
    PRINT USING "              ROTOR ##"; X; : INPUT " :  ", T(X)
    IF T(X) > 100 OR T(X) < 1 THEN
      BEEP
      GOTO REENTER1
      END IF

    CHECKSUM = CHECKSUM + T(X)

    T(X) = 202 - (T(X) * 2)
    
  NEXT X

REENTER2:
  LOCATE 11 + X + 1, 24
  COLOR 10, 0
  INPUT "REVERSING ROTOR    :  ", TR

  IF TR > 100 OR TR < 1 THEN
    BEEP
    GOTO REENTER2
    END IF

  COLOR 7, 0                          'WHITE/BLACK

  CHECKSUM = CHECKSUM + TR

  TR = 202 - (TR * 2)
  

TAB05:    '--------------------------- INITIAL SETTINGS SHIFT ROUTINE

   FOR X = 1 TO N
     F$ = " ": H$ = " "

     SELECT CASE X

       CASE 1
          F$ = MID$(R1(1), 1, 200 - T(X))
          H$ = MID$(R1(1), 201 - T(X))
          R1(1) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(1), 1, 200 - T(X))
          H$ = MID$(P0(1), 201 - T(X))
          P0(1) = H$ + F$
          RB$(1) = MID$(P0(1), 1, 2)  'BOTTOM OF SCREEN DISPLAY
   
       CASE 2
          F$ = MID$(R1(2), 1, 200 - T(X))
          H$ = MID$(R1(2), 201 - T(X))
          R1(2) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(2), 1, 200 - T(X))
          H$ = MID$(P0(2), 201 - T(X))
          P0(2) = H$ + F$
          RB$(2) = MID$(P0(2), 1, 2)
   
       CASE 3
          F$ = MID$(R1(3), 1, 200 - T(X))
          H$ = MID$(R1(3), 201 - T(X))
          R1(3) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(3), 1, 200 - T(X))
          H$ = MID$(P0(3), 201 - T(X))
          P0(3) = H$ + F$
          RB$(3) = MID$(P0(3), 1, 2)
         
       CASE 4
          F$ = MID$(R1(4), 1, 200 - T(X))
          H$ = MID$(R1(4), 201 - T(X))
          R1(4) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(4), 1, 200 - T(X))
          H$ = MID$(P0(4), 201 - T(X))
          P0(4) = H$ + F$
          RB$(4) = MID$(P0(4), 1, 2)
      
       CASE 5
          F$ = MID$(R1(5), 1, 200 - T(X))
          H$ = MID$(R1(5), 201 - T(X))
          R1(5) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(5), 1, 200 - T(X))
          H$ = MID$(P0(5), 201 - T(X))
          P0(5) = H$ + F$
          RB$(5) = MID$(P0(5), 1, 2)
      
       CASE 6
          F$ = MID$(R1(6), 1, 200 - T(X))
          H$ = MID$(R1(6), 201 - T(X))
          R1(6) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(6), 1, 200 - T(X))
          H$ = MID$(P0(6), 201 - T(X))
          P0(6) = H$ + F$
          RB$(6) = MID$(P0(6), 1, 2)

       CASE 7
          F$ = MID$(R1(7), 1, 200 - T(X))
          H$ = MID$(R1(7), 201 - T(X))
          R1(7) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(7), 1, 200 - T(X))
          H$ = MID$(P0(7), 201 - T(X))
          P0(7) = H$ + F$
          RB$(7) = MID$(P0(7), 1, 2)
      
       CASE 8
          F$ = MID$(R1(8), 1, 200 - T(X))
          H$ = MID$(R1(8), 201 - T(X))
          R1(8) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(8), 1, 200 - T(X))
          H$ = MID$(P0(8), 201 - T(X))
          P0(8) = H$ + F$
          RB$(8) = MID$(P0(8), 1, 2)
      
       CASE 9
          F$ = MID$(R1(9), 1, 200 - T(X))
          H$ = MID$(R1(9), 201 - T(X))
          R1(9) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(9), 1, 200 - T(X))
          H$ = MID$(P0(9), 201 - T(X))
          P0(9) = H$ + F$
          RB$(9) = MID$(P0(9), 1, 2)

       CASE 10
          F$ = MID$(R1(10), 1, 200 - T(X))
          H$ = MID$(R1(10), 201 - T(X))
          R1(10) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(10), 1, 200 - T(X))
          H$ = MID$(P0(10), 201 - T(X))
          P0(10) = H$ + F$
          RB$(10) = MID$(P0(10), 1, 2)

       CASE 11
          F$ = MID$(R1(11), 1, 200 - T(X))
          H$ = MID$(R1(11), 201 - T(X))
          R1(11) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(11), 1, 200 - T(X))
          H$ = MID$(P0(11), 201 - T(X))
          P0(11) = H$ + F$
          RB$(11) = MID$(P0(11), 1, 2)

       CASE 12
          F$ = MID$(R1(12), 1, 200 - T(X))
          H$ = MID$(R1(12), 201 - T(X))
          R1(12) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(12), 1, 200 - T(X))
          H$ = MID$(P0(12), 201 - T(X))
          P0(12) = H$ + F$
          RB$(12) = MID$(P0(12), 1, 2)
      
    END SELECT

  NEXT X
                                      'REVERSING ROTOR
          F$ = " ": H$ = " "
          F$ = MID$(RR$, 1, 200 - TR)
          H$ = MID$(RR$, 201 - TR)
          RR$ = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(PR$, 1, 200 - TR)
          H$ = MID$(PR$, 201 - TR)
          PR$ = H$ + F$
          R13$ = MID$(PR$, 1, 2)

  CLS
  IF CORR$ = "Y" THEN GOTO TAB07

REPEAT04:

  LOCATE 10, 20
  PRINT "DO YOU WANT TO SUPER-ENCIPHER (Y or N) ?"
REPEAT05: Q5$ = INKEY$: IF Q5$ = "" THEN GOTO REPEAT05
  IF Q5$ <> "N" AND Q5$ <> "Y" THEN GOTO REPEAT04

TAB07:

  IF Q5$ = "Y" THEN GOSUB TAB64

'------------------------------------ 'START OPERATION

  IF CORR$ = "Y" THEN GOTO TAB09
                                    
REPEAT06:  '-------------------------- START SCREEN

  F1 = FRE("")
  CLS
  GOSUB TAB113                        'CHECKSUM ROUTINE

  LOCATE 10, 17
  COLOR 2, 0
  PRINT "   To end operations and :"
  PRINT
  PRINT "                   1.  Print text     :  Press ";
  COLOR 4, 15                         'RED,BRIGHT WHITE
  PRINT " \ "
  PRINT
  COLOR 2, 0                          'GREEN, BLACK
  PRINT "                   2.  Correct input  :  Press ";
  COLOR 4, 15                         'RED/BRIGHT WHITE
  PRINT " Shift & | "
  COLOR 7, 0                          'WHITE, BLACK

TAB09: '------------------------------ INITIALIZE OUTPUT LOCATIONS

  C = 2: C1 = 1                       'COLUMNS - ENCODING
  D = 1: D1 = 2                       'COLUMNS - DECODING
  F = 1                               'LINES - DECODING
  G = 3                               'LINES - DECODING
  O$ = " "
  M$ = "  "
  J$ = "  "
 
  COLOR 14, 0                         'YELLOW ON BLACK
  LOCATE 25, 1                        'BOTTOM LINE OF SCREEN
  PRINT "Press ENTER key to start - or - to make the next screen";
  PRINT "                         ";
  DO
  LOOP WHILE INKEY$ = ""

  COLOR 7, 0                          'WHITE ON BLACK
  CLS

  LOCATE 10, 30
  COLOR 11, 0                         'LIGHT CYAN/BLACK
  PRINT "START ENTERING MESSAGE"
  COLOR 7, 0                          'WHITE/BLACK

  GOSUB TAB109                        'DISPLAY ROTORS AT BOTTOM OF SCREEN

  Z$ = O$

  I = 0: K = 0

TAB10:  '---------------------------- 'E/D SWITCH
  
  IF Q$ = "1" THEN GOTO TAB11         'ENCIPHER
  IF Q$ = "2" THEN GOTO TAB14         'DECIPHER
  GOTO REPEAT06                       'CHECK FOR CORRECT INPUT


TAB11: '---------------ENCIPHER------- ENTER CLEARTEXT CHARACTERS

  IF X5 = 0 THEN GOTO TAB12           'TO KEYBOARD ENTRY IF X5=0

  X4 = X4 + 1                         'AUTOMATIC ENTRY WHEN CORRECTING
  IF X4 >= X2 THEN GOTO TAB12         'LIMIT NUMBER OF AUTOMATIC INPUTS TO X2
  B$ = MID$(K1$, X4, 1)               'SELECT X4th ENTRY FOR INPUT

  Y6$ = MID$(Y4$, 1, RV)              'SHIFT CHARACTER SET
  Y7$ = MID$(Y4$, RV + 1)
  Y4$ = Y7$ + Y6$

  Y1 = INSTR(Y4$, " ")                'LOCATE BLANK SPACE
  Y1$ = STR$(Y1)                      'ASSIGN VALUE TO SPACE

  GOTO TAB13


TAB12:  '----------------------------- DATA ENTRY ROUTINE (KEYBOARD)
 
  E5 = 1                              'BLANK ABOVE MESSAGE FLAG
  X5 = 0                              'SET FOR KEYBOARD ENTRY
  N2 = 0                              'RESET ROTORS PASS COUNTER
  DO
    B$ = INKEY$                       'ENTER CLEARTEXT
  LOOP UNTIL B$ <> ""

  IF B$ = "\" OR B$ = "|" THEN
    LOCATE 10, 30
    PRINT "                      "    'ERASE START MESSAGE SIGN
    GOTO TAB13                        'TO PROCESS INPUT
    END IF
   
  IF E5 = 1 THEN
    LOCATE 10, 30
    PRINT "                      "    'ERASE START MESSAGE SIGN
    END IF
                                      'CONVERT INPUT USING CHARACTER SET BY
  B1 = INSTR(Y4$, B$)                 'DETERMINING INPUT POSITIONAL VALUE

  IF B1 = 0 AND B$ <> "A" THEN        'B1=0 MEANS B$ NOT IN Y4$
    BEEP
    GOTO TAB12                        'RE-ENTER INPUT
    END IF

  Y6$ = MID$(Y4$, 1, RV)              'SHIFT CHARACTER SET
  Y7$ = MID$(Y4$, RV + 1)
  Y4$ = Y7$ + Y6$

  Y1 = INSTR(Y4$, " ")                'LOCATE BLANK SPACE
  Y1$ = STR$(Y1)                      'ASSIGN VALUE TO SPACE

  
TAB13:  '----------------------------- PROCESS INPUT

  IF B$ = "|" THEN                    'CORRECTION PROCEDURE
    CORR$ = "Y"
    M5 = 0
    END IF

  Z$ = B$

  LOCATE 24, 1
  COLOR 10, 0                         'GREEN/BLACK
  PRINT "Enter '\' to end message.   Press 'Shift |' to make correction.";
  U1 = U1 + 1                         'COUNT INPUT
  LOCATE 24, 65
  PRINT USING "Input No. ####"; U1;
  COLOR 7, 0                          'WHITE/BLACK

  LOCATE F, C
  PRINT B$                            'PRINT CLEARTEXT INPUT
  C = C + 3

  A = INSTR(Y4$, B$)                  'FIND INPUT POSITION IN BASE CHAR SET
  A$ = C$(A)                          'CONVERT CHARACTER TO CODE NUMBER
  IF A$ = "00" THEN A$ = "100"        'ADJUST POSITION VALUE
  IF B$ = "" THEN A$ = Y1$            'ASSIGN CODE NUMBER TO "SPACE"
  I3(VAL(A$)) = I3(VAL(A$)) + 1       'COUNT OF INPUT CHARACTERS

  GOSUB TAB78                         'TALLY INPUT COUNT

  IF Q$ = "1" THEN
    O1$ = "ENCRYPTION"
    ELSE
    O1$ = "DECRYPTION"
    END IF
  LPRINT O1$
  LPRINT
  LPRINT "Input = "; B$;
  LPRINT TAB(20); "Rotation Values : ";
  LPRINT "CS ="; RV; "   ";
  FOR B9 = 1 TO N
    LPRINT "R"; STR$(B9); " ="; S(B9); "   ";
  NEXT B9
  LPRINT "RR ="; S(13)

  LPRINT TAB((A * 2) - 1); "V"
  FOR Y2 = 1 TO 100: LPRINT MID$(Y4$, Y2, 1); " "; : NEXT Y2: LPRINT " CS"
  LPRINT TAB((A * 2) - 1); A$         'PRINT NUMERIC POSITION OF INPUT

  GOSUB TAB60                         'THRU PLUGBOARD

  LPRINT TAB(S); M10$; M10$
  LPRINT Z1$; " PB"
  GOSUB TAB126                        'PRINT PLUGBOARD PATH - INPUT
  LPRINT Z2$; " PB"
  S = 1
  IF A$ = "100" THEN A$ = "00"
  FOR U = 1 TO 200 STEP 2
    IF A$ = MID$(Z1$, U, 2) THEN EXIT FOR
    S = S + 2
  NEXT U

  LPRINT TAB(S); M10$; M10$
  GOTO TAB26                          'TO COMMON OPERATION

TAB14:   '---------------------------- DECRYPTION ROUTINE SWITCHES

  IF X5 = 0 THEN GOTO TAB20           'TO KEYBOARD ENTRY IF X5=0

  Z5 = 1                              'AUTOMATIC ENTRY WHEN CORRECTING
  IF X4 >= (X2 * 2) - 2 THEN GOTO TAB20  'LIMIT NUMBER OF AUTOMATIC INPUTS
  A$ = MID$(I1$, Z5 + X4, 2)          'SELECT X4th ENTRY FOR INPUT
  X4 = X4 + 2
  GOTO TAB23                          'PROCESS INPUT

  IF CORR$ <> "Y" THEN GOTO TAB20     'NO CORRECTIONS
  T4 = T4 + 2

  IF T4 >= T2 - 1 THEN GOTO TAB20     'RECOVERY OF STORED INPUT
  A$ = MID$(I1$, T4, 2)

  IF Q5$ = "Y" THEN GOTO TAB23        'FOR SUPER DECRYPTION
  GOTO TAB24

TAB20: '------------------------------ CIPHER TEXT INPUT

  E5 = 1                              'ERASE START MESSAGE FLAG
  F1 = FRE("")
  N2 = 0                              'RESET ROTORS PASS COUNTER
  DO                                  'INPUT 1ST CIPHER DIGIT
    A1$ = INKEY$
    LOOP UNTIL A1$ <> ""

    IF ASC(A1$) = 13 THEN             'CHECK FOR BLANK ENTRY
      BEEP
      GOTO TAB20
      END IF

  Z$ = A1$

  IF Q5$ = "N" THEN                   'NOT SUPER ENCIPHERED
     SELECT CASE A1$                  '1ST CHARACTER ENTERED
       CASE "0" TO "9"                'MUST BE NUMERIC
         GOTO TAB21                   'O.K.
       CASE ELSE                      'NOT NUMERIC (ERROR)
         BEEP
         GOTO TAB20                   'RE-ENTER
     END SELECT
  END IF

  IF Q5$ = "Y" THEN                   'SUPER ENCIPHERED
    SELECT CASE A1$                   '1ST CHARACTER ENTERED
      CASE "A" TO "Z"                 'MUST BE ALPHA
        GOTO TAB21                    'O.K.
      CASE ELSE                       'NOT ALPHA (ERROR)
        BEEP
        GOTO TAB20                    'RE-ENTER
    END SELECT
  END IF

TAB21:
 
  DO                                  'INPUT 2ND CIPHER DIGIT
    A2$ = INKEY$
  LOOP UNTIL A2$ <> ""
    IF ASC(A2$) = 13 THEN             'CHECK FOR BLANK ENTRY
      BEEP
      GOTO TAB20
      END IF

  IF Q5$ = "N" THEN                   'NOT SUPER ENCIPHERED
     SELECT CASE A2$                  '2ND CHARACTER ENTERED
       CASE "0" TO "9"                'MUST BE NUMERIC
         GOTO TAB22                   'O.K.
       CASE ELSE                      'NOT NUMERIC (ERROR)
         BEEP
         GOTO TAB20                   'RE-ENTER BOTH DIGITS
     END SELECT
  END IF

  IF Q5$ = "Y" THEN                   'SUPER ENCIPHERED
    SELECT CASE A2$                   '2ND CHARACTER ENTERED
      CASE "A" TO "Z"                 'MUST BE ALPHA
        GOTO TAB22                    'O.K.
      CASE ELSE                       'NOT ALPHA (ERROR)
        BEEP
        GOTO TAB20                    'RE-ENTER BOTH CHARACTERS
    END SELECT
  END IF

TAB22:

   A$ = A1$ + A2$                     'COMBINE

  IF E5 = 1 THEN                      'ERASE START MESSAGE SIGN
    LOCATE 10, 30
    PRINT "                      "
    END IF

TAB23:  ' ---------------------------- SUPER DECIPHERMENT PRINTING

  A4$ = A$
  IF Q5$ = "Y" THEN GOSUB TAB72       'SUPER DECIPHERMENT
  LPRINT "DECRYPTION"
  LPRINT
  LPRINT "Input = "; A4$
  LPRINT
  LPRINT A4$; " Super Deciphered = "; A$; "   ( Row = "; R3; "  Col = "; C3; " )"
  LPRINT

TAB24:  ' ---------------------------- SUPER ENCIPHERMENT INPUT

  A3$ = A$                            'SAVE FOR PRINTING
  IF Q5$ = "Y" THEN A3$ = A4$         'SUPERDECIPHERMENT INPUT
  
  GOSUB TAB60                         'THRU PLUGBOARD
  IF A$ = "00" THEN A$ = "100"
  IF Q5$ = "Y" THEN
    LPRINT TAB(S); M10$; M10$
  ELSE
    LPRINT TAB((VAL(A$) * 2) - 1); M10$; M10$
  END IF
  LPRINT Z1$; " PB"
  GOSUB TAB126                        'PRINT PLUGBOARD PATH - INPUT
  LPRINT Z2$; " PB"

  IF Q5$ <> "Y" THEN
    S = 1
    IF A$ = "100" THEN A$ = "00"
    FOR U = 1 TO 200 STEP 2
      IF A$ = MID$(Z2$, U, 2) THEN EXIT FOR
      S = S + 2
    NEXT U
  ELSE
    S = 1
    IF A$ = "100" THEN A$ = "00"
    FOR U = 1 TO 200 STEP 2
      IF A$ = MID$(Z1$, U, 2) THEN EXIT FOR
      S = S + 2
    NEXT U
  END IF

  LPRINT TAB(S); M10$; M10$

  LOCATE F, D
  PRINT A3$
  IF A$ = "00" THEN A$ = "100"
  D = D + 3

TAB26: '------------------------------ COMMON TO ENCIPHER & DECIPHER

  IF A$ = "00" THEN A$ = "100"
  L = (VAL(A$) * 2) - 1               'ENTRY STATOR

  LPRINT TAB(L); M10$; M10$

  P$ = P0(1)                          'ROTOR 1
  R$ = R1(1)
  GOSUB TAB38
  RO$ = "1"
  GOSUB TAB118                        'PRINT ROTOR CONTENTS (OPTIONAL)
  J = 1: IF J = N THEN GOTO RR

  P$ = P0(2)                          'ROTOR 2
  R$ = R1(2)
  GOSUB TAB38
  RO$ = "2"
  GOSUB TAB118
  J = 2: IF J = N THEN GOTO RR

  P$ = P0(3)                          'ROTOR 3
  R$ = R1(3)
  GOSUB TAB38
  RO$ = "3"
  GOSUB TAB118
  J = 3: IF J = N THEN GOTO RR

  P$ = P0(4)                          'ROTOR 4
  R$ = R1(4)
  GOSUB TAB38
  RO$ = "4"
  GOSUB TAB118
  J = 4: IF J = N THEN GOTO RR

  P$ = P0(5)                          'ROTOR 5
  R$ = R1(5)
  GOSUB TAB38
  RO$ = "5"
  GOSUB TAB118
  J = 5: IF J = N THEN GOTO RR

  P$ = P0(6)                          'ROTOR 6
  R$ = R1(6)
  GOSUB TAB38
  RO$ = "6"
  GOSUB TAB118
  J = 6: IF J = N THEN GOTO RR

  P$ = P0(7)                          'ROTOR 7
  R$ = R1(7)
  GOSUB TAB38
  RO$ = "7"
  GOSUB TAB118
  J = 7: IF J = N THEN GOTO RR

  P$ = P0(8)                          'ROTOR 8
  R$ = R1(8)
  GOSUB TAB38
  RO$ = "8"
  GOSUB TAB118
  J = 8: IF J = N THEN GOTO RR

  P$ = P0(9)                          'ROTOR 9
  R$ = R1(9)
  GOSUB TAB38
  RO$ = "9"
  GOSUB TAB118
  J = 9: IF J = N THEN GOTO RR

  P$ = P0(10)                         'ROTOR 10
  R$ = R1(10)
  GOSUB TAB38
  RO$ = "10"
  GOSUB TAB118
  J = 10: IF J = N THEN GOTO RR

  P$ = P0(11)                         'ROTOR 11
  R$ = R1(11)
  GOSUB TAB38
  RO$ = "11"
  GOSUB TAB118
  J = 11: IF J = N THEN GOTO RR
 
  P$ = P0(12)                         'ROTOR 12
  R$ = R1(12)
  GOSUB TAB38
  RO$ = "12"
  GOSUB TAB118
  J = 12: IF J = N THEN GOTO RR

RR:
  P$ = PR$                            'REVERSING ROTOR
  R$ = RR$
  GOSUB TAB38
  RO$ = "R"

  IF Q$ = "2" THEN SWAP P$, R$
  IF Q$ = "2" THEN Q1$ = "D"          'DECRYPTION FLAG
  GOSUB TAB118
  Q1$ = " "                           'CANCEL FLAG
  SWAP P$, R$

  ON N GOTO R01, R02, R03, R04, R05, R06, R07, R08, R09, R10, R11, R12

R12:
  P$ = R1(12)                         'ROTOR 12
  R$ = P0(12)
  GOSUB TAB38
  RO$ = "12"
  GOSUB TAB118
 
R11:
  P$ = R1(11)                         'ROTOR 11
  R$ = P0(11)
  GOSUB TAB38
  RO$ = "11"
  GOSUB TAB118

R10:
  P$ = R1(10)                         'ROTOR 10
  R$ = P0(10)
  GOSUB TAB38
  RO$ = "10"
  GOSUB TAB118
 
R09:
  P$ = R1(9)                          'ROTOR 9
  R$ = P0(9)
  GOSUB TAB38
  RO$ = "9"
  GOSUB TAB118
 
R08:
  P$ = R1(8)                          'ROTOR 8
  R$ = P0(8)
  GOSUB TAB38
  RO$ = "8"
  GOSUB TAB118
 
R07:
  P$ = R1(7)                          'ROTOR 7
  R$ = P0(7)
  GOSUB TAB38
  RO$ = "7"
  GOSUB TAB118
 
R06:
  P$ = R1(6)                          'ROTOR 6
  R$ = P0(6)
  GOSUB TAB38
  RO$ = "6"
  GOSUB TAB118
 
R05:
  P$ = R1(5)                          'ROTOR 5
  R$ = P0(5)
  GOSUB TAB38
  RO$ = "5"
  GOSUB TAB118
 
R04:
  P$ = R1(4)                          'ROTOR 4
  R$ = P0(4)
  GOSUB TAB38
  RO$ = "4"
  GOSUB TAB118
  
R03:
  P$ = R1(3)                          'ROTOR 3
  R$ = P0(3)
  GOSUB TAB38
  RO$ = "3"
  GOSUB TAB118
 
R02:
  P$ = R1(2)                          'ROTOR 2
  R$ = P0(2)
  GOSUB TAB38
  RO$ = "2"
  GOSUB TAB118
 
R01:
  P$ = R1(1)                          'ROTOR 1
  R$ = P0(1)
  GOSUB TAB38
  RO$ = "1"
  GOSUB TAB118
 
  IF Q$ = "2" THEN GOTO TAB28         'TO PRINT CLEARTEXT OUTPUT

  R$ = P0$                            'EXIT STATOR
  LOCATE G, C1
  J$ = MID$(R$, L, 2)

  A$ = J$
  GOSUB TAB60                         'THRU PLUGBOARD
  J$ = A$
  LPRINT Z2$; " PB"

  GOSUB TAB126                        'PRINT PLUGBOARD PATH - OUTPUT

  LPRINT Z1$; " PB"
  S = 1
  IF A$ = "100" THEN A$ = "00"
  FOR U = 1 TO 200 STEP 2
    IF A$ = MID$(Z1$, U, 2) THEN EXIT FOR
    S = S + 2
  NEXT U

  LPRINT TAB(S); M10$; M10$
  LPRINT "Code Out = "; J$
  LPRINT

  IF Q5$ = "Y" THEN GOSUB TAB70       'SUPER ENCIPHER INTO ALPHA
  LPRINT CHR$(12)                     'FORM FEED

  IF G = 23 AND W = 161 THEN
     PRINT J$;                        'PRINT OUTPUT CODE
  ELSE
     PRINT J$                         'PRINT OUTPUT CODE
  END IF

  IF Q5$ <> "Y" THEN GOSUB TAB80      'COUNT OUTPUT CODE
 
  O(VAL(J$)) = O(VAL(J$)) + 1         'OUTPUT COUNT

  GOSUB TAB48                         'STORE FOR PRINTER

  GOSUB TAB44                         'TO ROTOR SHIFT ROUTINE

  GOSUB TAB40                         'SCREEN END-OF-LINE ROUTINE

  IF G > 23 THEN GOTO TAB09           'CLEAR AND START NEW SCREEN

  GOTO TAB10                          'TO BEGINING FOR NEXT INPUT


TAB28: '------------------------------ DECIPHER ROUTINE

  L = 1
  FOR U = 1 TO 200 STEP 2
    IF M$ = MID$(P0(1), U, 2) THEN EXIT FOR
    L = L + 1
  NEXT U

  GOSUB TAB62                         'THRU PLUGBOARD

  LPRINT Z2$; " PB"
  GOSUB TAB126                        'PRINT PATH
  LPRINT Z1$; " PB"
  S = 1
  IF A$ = "100" THEN A$ = "00"
  FOR U = 1 TO 200 STEP 2
    IF A$ = MID$(Z1$, U, 2) THEN EXIT FOR
    S = S + 2
  NEXT U

  LPRINT TAB(S); M10$; M10$

  Y6$ = MID$(Y4$, 1, RV)              'SHIFT CHARACTER SET
  Y7$ = MID$(Y4$, RV + 1)
  Y4$ = Y7$ + Y6$

  Y1 = INSTR(Y4$, " ")                'LOCATE BLANK SPACE
  Y1$ = STR$(Y1)                      'ASSIGN VALUE TO SPACE
  FOR Y2 = 1 TO 100: LPRINT MID$(Y4$, Y2, 1); " "; : NEXT Y2: LPRINT " CS"
  LPRINT TAB(S); M10$; M10$
  LPRINT "Code Out = "; A$
  LPRINT
  LPRINT A$; " Converted to Cleartext = "; MID$(Y4$, VAL(A$), 1)

  G$ = MID$(Y4$, L, 1)                'CONVERT TO CLEARTEXT CHARACTER
  LOCATE G, D1
  PRINT G$;                           'PRINT CLEARTEXT OUTPUT

  LOCATE 24, 1
  COLOR 10, 0                         'GREEN/BLACK
  PRINT "Enter '\' to end message.   Press 'Shift |' to make correction.";
  U1 = U1 + 1                         'COUNT INPUT
  LOCATE 24, 65
  COLOR 14, 0                         'YELLOW/BLACK
  PRINT USING "Output No. ####"; U1;
  COLOR 7, 0                          'WHITE/BLACK

  GOSUB TAB48                         'STORE FOR PRINTER

  GOSUB TAB44                         'SHIFT ROUTINE
  
  GOSUB TAB40                         'SCREEN END-OF-LINE ROUTINE

  IF G > 23 THEN GOTO TAB09           'CLEAR AND START NEW SCREEN

  GOTO TAB10                          'START WITH NEW INPUT


  
TAB35: '------------------------------ CORRECTION PROCEDURE

  I1$ = I(1)                          'CUMULATIVE OUTPUT CODE
  I1$ = RTRIM$(I1$)                   'CUMULATIVE OUTPUT CODE
  K1$ = K(1)                          'CUMULATIVE INPUT CLEARTEXT
  X5 = 1                              'GO TO AUTOMATIC INPUT MODE
  X4 = 0                              'INPUT COUNTER FOR AUTOMATIC INPUT
  
  GOSUB TAB108                        'POSITION NUMBERS ON SCREEN
  
  T4 = -1
  T2 = LEN(I1$)                       'COUNT OF OUTPUT CHARACTERS
  W = 0                               'RESET SCREEN INPUT COUNT
  W1 = 1
  W2 = 1
 
  GOTO TAB03                          'BEGIN NEW MESSAGE

TAB36:  '----------------------------- END SESSION
 
  CLS
  COLOR 14, 0                         'YELLOW, BLACK
  LOCATE 10, 10
  INPUT "DO YOU WANT A CHARACTER FREQUENCY ANALYSIS (Y or N) ", A5$
  COLOR 7, 0                          'WHITE, BLACK
  IF A5$ = "N" THEN GOTO TAB37
 
  IF Q5$ <> "Y" THEN GOTO TAB37       'Q5$ = "Y" = SUPERENCIPHERMENT


TAB37:

END

TAB38:  ' ---------------------------- POSITION OF CODE NUMBER M$ IN P$
  
  M$ = MID$(P$, L, 2)
  L = 1
  FOR U = 1 TO 200 STEP 2
    IF M$ = MID$(R$, U, 2) THEN EXIT FOR
    L = L + 2
  NEXT U

  RETURN


TAB40:  '----------------------------- SCREEN END-OF-LINE ROUTINE

  C1 = C1 + 3: D1 = D1 + 3
  IF C1 > 81 OR D1 > 81 THEN
     LOCATE G + 1, 1
     COLOR 14                         'YELLOW
     FOR V = 1 TO 80: PRINT "-"; : NEXT V
     IF G = 23 THEN
        PRINT ;
     ELSE
        PRINT
     END IF

     COLOR 7                          'WHITE
     C1 = 1
     C = 2
     D = 1
     D1 = 2
     F = F + 4
     G = G + 4
  END IF

  RETURN
    

TAB44:  '----------------------------- SHIFT ROUTINE
  
  FOR X = 1 TO N
    F$ = " ": H$ = " "

    SELECT CASE X

       CASE 1
          F$ = MID$(R1(1), 1, 200 - S1A)
          H$ = MID$(R1(1), 201 - S1A)
          R1(1) = H$ + F$             'ROTOR DESTINATION SIDE
          F$ = " ": H$ = " "
          F$ = MID$(P0(1), 1, 200 - S1A)
          H$ = MID$(P0(1), 201 - S1A)
          P0(1) = H$ + F$             'ROTOR POSITION SIDE (00-99)
          RB$(1) = MID$(P0(1), 1, 2)  'BOTTOM OF SCREEN DISPLAY

       CASE 2
          F$ = MID$(R1(2), 1, 200 - S2A)
          H$ = MID$(R1(2), 201 - S2A)
          R1(2) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(2), 1, 200 - S2A)
          H$ = MID$(P0(2), 201 - S2A)
          P0(2) = H$ + F$
          RB$(2) = MID$(P0(2), 1, 2)

       CASE 3
          F$ = MID$(R1(3), 1, 200 - S3A)
          H$ = MID$(R1(3), 201 - S3A)
          R1(3) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(3), 1, 200 - S3A)
          H$ = MID$(P0(3), 201 - S3A)
          P0(3) = H$ + F$
          RB$(3) = MID$(P0(3), 1, 2)

       CASE 4
          F$ = MID$(R1(4), 1, 200 - S4A)
          H$ = MID$(R1(4), 201 - S4A)
          R1(4) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(4), 1, 200 - S4A)
          H$ = MID$(P0(4), 201 - S4A)
          P0(4) = H$ + F$
          RB$(4) = MID$(P0(4), 1, 2)

       CASE 5
          F$ = MID$(R1(5), 1, 200 - S5A)
          H$ = MID$(R1(5), 201 - S5A)
          R1(5) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(5), 1, 200 - S5A)
          H$ = MID$(P0(5), 201 - S5A)
          P0(5) = H$ + F$
          RB$(5) = MID$(P0(5), 1, 2)

       CASE 6
          F$ = MID$(R1(6), 1, 200 - S6A)
          H$ = MID$(R1(6), 201 - S6A)
          R1(6) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(6), 1, 200 - S6A)
          H$ = MID$(P0(6), 201 - S6A)
          P0(6) = H$ + F$
          RB$(6) = MID$(P0(6), 1, 2)

       CASE 7
          F$ = MID$(R1(7), 1, 200 - S7A)
          H$ = MID$(R1(7), 201 - S7A)
          R1(7) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(7), 1, 200 - S7A)
          H$ = MID$(P0(7), 201 - S7A)
          P0(7) = H$ + F$
          RB$(7) = MID$(P0(7), 1, 2)
      
       CASE 8
          F$ = MID$(R1(8), 1, 200 - S8A)
          H$ = MID$(R1(8), 201 - S8A)
          R1(8) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(8), 1, 200 - S8A)
          H$ = MID$(P0(8), 201 - S8A)
          P0(8) = H$ + F$
          RB$(8) = MID$(P0(8), 1, 2)
      
       CASE 9
          F$ = MID$(R1(9), 1, 200 - S9A)
          H$ = MID$(R1(9), 201 - S9A)
          R1(9) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(9), 1, 200 - S9A)
          H$ = MID$(P0(9), 201 - S9A)
          P0(9) = H$ + F$
          RB$(9) = MID$(P0(9), 1, 2)
      
       CASE 10
          F$ = MID$(R1(10), 1, 200 - S10A)
          H$ = MID$(R1(10), 201 - S10A)
          R1(10) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(10), 1, 200 - S10A)
          H$ = MID$(P0(10), 201 - S10A)
          P0(10) = H$ + F$
          RB$(10) = MID$(P0(10), 1, 2)

       CASE 11
          F$ = MID$(R1(11), 1, 200 - S11A)
          H$ = MID$(R1(11), 201 - S11A)
          R1(11) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(11), 1, 200 - S11A)
          H$ = MID$(P0(11), 201 - S11A)
          P0(11) = H$ + F$
          RB$(11) = MID$(P0(11), 1, 2)

       CASE 12
          F$ = MID$(R1(12), 1, 200 - S12A)
          H$ = MID$(R1(12), 201 - S12A)
          R1(12) = H$ + F$
          F$ = " ": H$ = " "
          F$ = MID$(P0(12), 1, 200 - S12A)
          H$ = MID$(P0(12), 201 - S12A)
          P0(12) = H$ + F$
          RB$(12) = MID$(P0(12), 1, 2)
      
       END SELECT

  NEXT X

                                      'REVERSING ROTOR
          F$ = " ": H$ = " "
          F$ = MID$(RR$, 1, 200 - SRA)
          H$ = MID$(RR$, 201 - SRA)
          RR$ = H$ + F$

          F$ = " ": H$ = " "
          F$ = MID$(PR$, 1, 200 - SRA)
          H$ = MID$(PR$, 201 - SRA)
          PR$ = H$ + F$
          R13$ = MID$(PR$, 1, 2)

  GOSUB TAB109

  RETURN


TAB48:   '--------------------------- 'STORE DATA FOR PRINTER AND PRINT

  SELECT CASE Q$
     CASE "1"                         'ENCIPHER
        K = K + 1                     'CLEARTEXT INPUT COUNTER
        I = I + 1                     'CODE OUTPUT COUNTER
        MID$(K(1), K, 1) = B$         'CLEAR INPUT
        MID$(I(1), I, 2) = J$         'CODE OUTPUT
        I = I + 1
        HC = HC + VAL(J$)             'ACCUMULATE OUTPUT HASH COUNT TOTAL
        O1$ = "ENCRYPTION"

     CASE "2"                         'DECIPHER
        I = I + 1                     'CODE INPUT COUNTER
        K = K + 1                     'CLEARTEXT OUTPUT COUNTER
        MID$(I(1), I, 2) = A3$        'CODE INPUT
        MID$(K(1), K, 1) = G$         'CLEAR OUTPUT
        I = I + 1
        HC = HC + VAL(A3$)            'ACCUMULATE INPUT HASH COUNT TOTAL
        O1$ = "DECRYPTION"

  END SELECT

  W = W + 1                           'COUNTER FOR BEEPS
  IF W > 158 THEN BEEP                'END-OF-SCREEN CHECK & WARNING
  IF W = 162 THEN                     'PRINT SCREEN CONTENTS

     END IF

  RETURN


TAB59:  '----------------------------- SET PLUGBOARD

  FOR N8 = 1 TO 100: E1(N8) = 0: NEXT N8

  LOCATE 3, 10
  COLOR 14, 0
 
  INPUT "SOI : ENTER THE NUMBER PLUGBOARD CONNECTIONS TO SET :  ", N1
 
  COLOR 7, 0
  IF N1 > 50 THEN
    BEEP
    GOTO TAB59
    END IF

  CHECKSUM1 = CHECKSUM1 + N1

  LOCATE 17, 21
  PRINT "Plugboard Positions not yet selected"

  P1$ = P0$
  Z10 = 1
  FOR N7 = 1 TO 5
  LOCATE , 10
  FOR N9 = 1 TO 20
    LOCATE 18 + N7
    PRINT MID$(P1$, Z10, 2); " ";
    Z10 = Z10 + 2
  NEXT N9: PRINT
  NEXT N7
 
  N6 = 5
  FOR X = 1 TO N1
    N5 = N5 + 1
    IF N5 > 10 THEN
      N5 = 1
      N6 = N6 + 15
      END IF
     
REENTER:
    LOCATE 5 + N5, N6
    PRINT USING "SET ## : "; X;
    INPUT "", B3$
    IF LEN(B3$) <> 4 THEN GOTO REENTER
    LOCATE 2, 15
    PRINT STRING$(45, " ")
    B1$ = MID$(B3$, 1, 2)             '1ST NUMBER
    B2$ = MID$(B3$, 3, 2)             '2ND NUMBER

      IF B1$ = B2$ THEN
        BEEP
        GOTO REENTER
        END IF

    B11 = VAL(B1$): IF B11 = 0 THEN B11 = 100
    B12 = VAL(B2$): IF B12 = 0 THEN B12 = 100

    IF E1(B11) = 0 AND E1(B12) = 0 THEN   'CHECK FOR DUPLICATION
       E1(B11) = B11
       E1(B12) = B12
    ELSE
       BEEP
       LOCATE 2, 20
       COLOR 30, 0
       PRINT "Duplicate Plug connection.  Re-enter."
       COLOR 7, 0
       GOTO REENTER
    END IF

    PB$(X) = B3$                      'STORE CONNECTIONS FOR LISTING

    S = 1
   
    FOR U = 1 TO 200 STEP 2
      IF B1$ = MID$(Z1$, U, 2) THEN EXIT FOR
      S = S + 2
    NEXT U

    T = 1

    FOR U = 1 TO 200 STEP 2
      IF B2$ = MID$(Z1$, U, 2) THEN EXIT FOR
      T = T + 2
    NEXT U

    MID$(Z2$, S, 2) = MID$(Z1$, T, 2)
    MID$(Z2$, T, 2) = MID$(Z1$, S, 2)
    CHECKSUM1 = CHECKSUM1 + B11 + B12
    IF B1$ = "00" THEN B1$ = "100"
    IF B2$ = "00" THEN B2$ = "100"
    MID$(P1$, (VAL(B1$) * 2) - 1, 2) = "  "
    MID$(P1$, (VAL(B2$) * 2) - 1, 2) = "  "

    Z10 = 1
    FOR N7 = 1 TO 5
      LOCATE , 10
      FOR N9 = 1 TO 20
        LOCATE 18 + N7
        PRINT MID$(P1$, Z10, 2); " ";
        Z10 = Z10 + 2
      NEXT N9: PRINT

    NEXT N7

  NEXT X

  RETURN


TAB60:   '---------------------------- THRU PLUGBOARD - ENCIPHER

  S = 1
  IF A$ = "100" THEN A$ = "00"
  FOR U = 1 TO 200 STEP 2
    IF A$ = MID$(Z1$, U, 2) THEN EXIT FOR
    S = S + 2
  NEXT U

  A$ = MID$(Z2$, S, 2)

  RETURN

TAB62:   '---------------------------- THRU PLUGBOARD - DECIPHER

  S = (L * 2) - 1
  A$ = MID$(Z2$, S, 2)
  IF A$ = "00" THEN A$ = "100"
  L = VAL(A$)

  RETURN


TAB64:   '---------------------------- ALPHA SUPER ENCIPHERING

  GOSUB TAB76                         'READ TABLE FROM DISK FILE

  D2 = 1
  FOR B = 1 TO 100
    FOR C2 = 1 TO 8
      F$(B, C2) = MID$(N(1), D2, 2)
      D2 = D2 + 2
    NEXT C2
  NEXT B

  N(1) = ""

  FOR B = 1 TO 100
    FOR C2 = 1 TO 7
      IF F$(B, C2) = "  " THEN GOTO SKIP08
      Z1 = INSTR(M3$, MID$(F$(B, C2), 1, 1))     ' COL CODE - 1ST ALPHA
      Z3 = INSTR(M3$, MID$(F$(B, C2), 2, 1))     ' COL CODE - 2ND ALPHA
      V$ = STR$(B)
      T$ = "00"

      SELECT CASE B                   'CREATE LOCATOR CELL DATA
        CASE 1 TO 9
          MID$(T$, 2, 1) = MID$(V$, 2, 1)
        CASE 10 TO 99
          MID$(T$, 1, 2) = MID$(V$, 2, 2)
        CASE 100
          T$ = "00"
      END SELECT

      J(Z1, Z3) = T$

SKIP08:

    NEXT C2

  NEXT B
  IF Q$ = "2" THEN RETURN             '2 = DECIPHER

TAB66:  '----------------------------- SET SUPERENCIPHERMENT COUNTER (1 TO 6)

  LOCATE 14, 20
  INPUT "SET INITIAL COUNT (1 TO 6)            ", SE
  FOR U4 = 1 TO 100
    C(U4) = SE
  NEXT U4
  IF SE < 1 OR SE > 6 THEN
    BEEP
    GOTO TAB66
    END IF

  RETURN


TAB70:   '---------------------------- SUPER ENCIPHER INTO ALPHA

  J2$ = J$

  R1 = VAL(J$)                        'ROW No.
  IF J$ = "00" THEN R1 = 100          'ADJUST FOR '00' TO '100'
  IF F$(R1, C(R1)) = "  " THEN C(R1) = 1     'CHECK FOR END OF ROW
  J$ = F$(R1, C(R1))                  'ALPHA SUPERENCIPHERMENT

GOSUB TAB122                          'PRINT SUPERENCIPHERMENT INFO

  C(R1) = C(R1) + 1                   'INCREMENT COL. COUNT

  G1 = INSTR(M3$, MID$(J$, 1, 1))     'POSITION OF 1ST CHARACTER
  G2 = INSTR(M3$, MID$(J$, 2, 1))     'POSITION OF 2ND CHARACTER
  G(G1, G2) = G(G1, G2) + 1           'SUPERENCIPHERMENT TALLY

  RETURN

TAB72:   '---------------------------- SUPER DECIPHERMENT FROM ALPHA

  R3 = INSTR(M3$, MID$(A$, 1, 1))     'ROW
  C3 = INSTR(M3$, MID$(A$, 2, 1))     'COL
  A$ = J(R3, C3)

  RETURN


TAB74:       '------------------------ RANDOM ACCESS DISK FILE FOR ROTORS
 
  TYPE ROTORSET
     ROTOR AS STRING * 200
  END TYPE

  DIM ROTORS AS ROTORSET

  OPEN "B:ROTORS.DAT" FOR RANDOM AS #1 LEN = 200

  NUM.RECS = LOF(1) / 200
 
  FOR X = 1 TO N                      'READ ROTORS FROM DISK
    ROTORNUM = A(X)
    GET #1, ROTORNUM, ROTORS
    R(X) = ROTORS.ROTOR

    FOR X7 = 1 TO 200                 'CHANGE BLANKS TO ZEROS
      IF MID$(R(X), X7, 1) = " " THEN MID$(R(X), X7, 1) = "0"
    NEXT X7

  NEXT X
  
  CLOSE #1
 
  RETURN


TAB76:  '--------------------- RANDOM ACCESS DISK FILE FOR SUPER ENCIPHERMENT

  CLS
 
  TYPE TABLE
     ALPHA AS STRING * 1600
  END TYPE

  DIM ARRAY AS TABLE
                                                     
  OPEN "B:CODE.DAT" FOR RANDOM AS #1 LEN = 1600

  NUM.RECS = LOF(1) / 1600

  CLS
  IF CORR$ = "Y" THEN GOTO SKIP09
  LOCATE 8, 25
  PRINT "    (See current S.O.I)"
  LOCATE 10, 20
  PRINT "SUPERCIPHERMENT TABLES AVAILABLE  =  "; NUM.RECS
REENTER3:
  LOCATE 12, 20
  COLOR 14, 0                         'YELLOW/BLACK
  INPUT "ENTER SUPERENCIPHERMENT TABLE NUMBER  ", TABLENO
  IF TABLENO > 100 OR TABLENO < 1 THEN
    BEEP
    GOTO REENTER3
    END IF
    CHECKSUM1 = CHECKSUM1 + TABLENO

  IF TABLENO > 50 THEN TABLENO = TABLENO - 50
  COLOR 7, 0                          'WHITE/BLACK
SKIP09:
  GET #1, TABLENO, ARRAY
  CLOSE #1

  N(1) = ARRAY.ALPHA
  
  RETURN


TAB78:        '----------------------- COUNT INPUT
  
  M4 = INSTR(M3$, B$)                 'NORMAL SEQUENTIAL VALUE OF INPUT
  M4$ = C$(M4)
  B(VAL(M4$)) = B(VAL(M4$)) + 1

  RETURN

TAB80:        '----------------------- COUNT OUTPUT

  J1$ = J$
  IF J$ = "00" THEN J1$ = "100"
  D(VAL(J1$)) = D(VAL(J1$)) + 1

  RETURN

 
TAB93:       '------------------------ ACCESS DISK FILE FOR REVERSING ROTOR
 
  TYPE REVROTRSET
       REVROTR AS STRING * 200
  END TYPE

  DIM REVROTRS AS REVROTRSET

  OPEN "B:REVROTRS.DAT" FOR RANDOM AS #1 LEN = 200

  NUM.RECS = LOF(1) / 200
 
  PRINT
  IF CORR$ = "Y" THEN GOTO SKIP13

REPEAT07:
  COLOR 14, 0                         'YELLOW/BLACK
  INPUT ; "ENTER REVERSING ROTOR NUMBER (1 TO 100)  :   ", REVROTRNUM
    IF REVROTRNUM > 100 OR REVROTRNUM < 1 THEN
      BEEP
      GOTO REPEAT07
      END IF
  COLOR 7, 0                          'WHITE/BLACK
  PRINT

SKIP13:
  GET #1, REVROTRNUM, REVROTRS        'READ REVERSING ROTOR FROM DISK
  PRINT

  A6$ = REVROTRS.REVROTR

  CLOSE #1
  CHECKSUM1 = CHECKSUM1 + REVROTRNUM
  
  RETURN                              'TO TAB3
 
TAB96:  '------------------------ RANDOM ACCESS DISK FILE FOR CHARACTER BASE
 
  CLS

  IF ANOTHER$ = "Y" THEN
     Y4$ = Y$
     ANOTHER$ = "N"
     RETURN
     END IF

  TYPE CHARSET
     CHAR AS STRING * 100
  END TYPE

  DIM CHARS AS CHARSET
 
  OPEN "B:CHARS.DAT" FOR RANDOM AS #1 LEN = 100

  NUM.RECS = LOF(1) / 100

REPEAT08:
  CLS
  LOCATE 10, 25
  PRINT NUM.RECS; " CHARACTER SETS AVAILABLE"
  PRINT
  LOCATE 12, 25
  PRINT "       (See your list)"
  LOCATE 14, 25
  COLOR 14, 0                         'YELLOW/BLACK
  INPUT " ENTER CHARACTER SET NUMBER ", CHARNUM
  COLOR 7, 0                          'WHITE/BLACK
    IF CHARNUM > 100 OR CHARNUM < 1 THEN   'CHECK FOR INVALID CHARNUM
    BEEP
    GOTO REPEAT08
    END IF
  COLOR 7, 0                          'WHITE/BLACK
  CHECKSUM1 = CHECKSUM1 + CHARNUM
  GET #1, CHARNUM, CHARS

  CLOSE #1

  Y$ = CHARS.CHAR
  Y4$ = Y$                            'PRESERVE Y$ FOR NEXT MESSAGES STARTS
  GOSUB TAB115                        'ENTER ROTATIONAL SHIFT VALUE
  
  RETURN

 
TAB106:  '---------------------------- SAVE DUPLICATE OF ROTORS

  F5 = 1                              'FLAG TO INDICATE THIS ACTION
  U2 = U1                             'INPUT COUNT START FOR NEXT SCREEN
  M5 = 0                              'RESET COUNTER
  HC1 = HC                            'SAVE HASH TOTAL
  Y5$ = Y4$                           'SAVE CHARACTER SET

  IF Q5$ = "N" THEN                   'IF NOT SUPERENCIPHERED
    FOR M7 = 1 TO 27
      C5(M7) = C4(M7)                 'SAVE OUTPUT COL.s TALLY
    NEXT M7

    FOR M7 = 1 TO 100
      R5(M7) = R4(M7)                 'SAVE OUTPUT ROWs TALLY
      B1(M7) = B(M7)                  'SAVE INPUT FREQUENCY COUNTER
      D1(M7) = D(M7)                  'SAVE OUTPUT FREQUENCY COUNTER
    NEXT M7
  END IF

  IF Q5$ = "Y" THEN                   'IF SUPERENCIPHEED
    FOR M6 = 1 TO 100
      B1(M6) = B(M6)                  'SAVE INPUT FREQUENCY COUNTER
      C1(M6) = C(M6)                  'SAVE SUPERENCIPHERMENT COL. VALUES
    NEXT M6
    END IF

  R1A(1) = R1(1)                      'SAVE ROTOR POSITIONS
  P1A$ = P0(1)
   
  R1A(2) = R1(2)
  P2A$ = P0(2)

  R1A(3) = R1(3)
  P3A$ = P0(3)
  
  R1A(4) = R1(4)
  P4A$ = P0(4)

  R1A(5) = R1(5)
  P5A$ = P0(5)
  
  R1A(6) = R1(6)
  P6A$ = P0(6)

  R1A(7) = R1(7)
  P7A$ = P0(7)
  
  R1A(8) = R1(8)
  P8A$ = P0(8)

  R1A(9) = R1(9)
  P9A$ = P0(9)
  
  R1A(10) = R1(10)
  P10A$ = P0(10)

  R1A(11) = R1(11)
  P11A$ = P0(11)
  
  R1A(12) = R1(12)
  P12A$ = P0(12)

  RRA$ = RR$
  PRA$ = PR$
 
  FOR G7 = 1 TO 26                    'SUPERENCIPHERMENT OUTPUT ANALYSIS
    FOR G8 = 1 TO 26
      G5(G7, G8) = G(G7, G8)
    NEXT G8
  NEXT G7
 
  RETURN


TAB107:  '---------------------------- RESTORE ROTORS AFTER CORRECTION

  F5 = 0                              'FLAG TO INDICATE THIS ACTION
  U1 = U2                             'INPUT COUNT FROM PRIOR SCREEN
  HC = HC1                            'RESTORE HASH TOTAL
  Y4$ = Y5$                           'RESTORE CHARACTER SET

  IF Q5$ = "N" THEN                   'N = NOT SUPERENCIPHERED
    FOR M7 = 1 TO 27
      C4(M7) = C5(M7)                 'RESTORE OUTPUT COL.s TALLY
    NEXT M7

    FOR M7 = 1 TO 100
      R4(M7) = R5(M7)                 'RESTORE OUTPUT ROWs TALLY
      B(M7) = B1(M7)                  'RESTORE INPUT FREQUENCY COUNTER
      D(M7) = D1(M7)                  'RESTORE OUTPUT FREQUENCY COUNTER
    NEXT M7
  END IF

  IF Q5$ = "Y" THEN                   'Y = SUPERENCIPHERMENT MODE
    FOR M6 = 1 TO 100
      C(M6) = C1(M6)                  'RESTORE SUPERENCIPHERMENT COL. VALUES
      B(M6) = B1(M6)                  'RESTORE INPUT FREQUENCY COUNTER
    NEXT M6
    END IF
    
  R1(1) = R1A(1)                      'RESTORE ROTOR POSITIONS
  P0(1) = P1A$
  
  R1(2) = R1A(2)
  P0(2) = P2A$

  R1(3) = R1A(3)
  P0(3) = P3A$
 
  R1(4) = R1A(4)
  P0(4) = P4A$

  R1(5) = R1A(5)
  P0(5) = P5A$
 
  R1(6) = R1A(6)
  P0(6) = P6A$

  R1(7) = R1A(7)
  P0(7) = P7A$
 
  R1(8) = R1A(8)
  P0(8) = P8A$

  R1(9) = R1A(9)
  P0(9) = P9A$
 
  R1(10) = R1A(10)
  P0(10) = P10A$

  R1(11) = R1A(11)
  P0(11) = P11A$
 
  R1(12) = R1A(12)
  P0(12) = P12A$

  RR$ = RRA$
  PR$ = PRA$
 

  FOR G7 = 1 TO 26                    'SUPERENCIPHERMENT OUTPUT ANALYSIS
    FOR G8 = 1 TO 26
      G(G7, G8) = G5(G7, G8)
    NEXT G8
  NEXT G7

  F1 = FRE("")
  RETURN


TAB108:  '---------------------------- POSITION NUMBERS FOR CORRECTIONS

  RETURN

TAB109: '----------------------------- ROTOR DISPLAY AT BOTTOM OF SCREEN

LOCATE 25, 1                          'BOTTOM OF SCREEN
  COLOR 15, 0                         'BRIGHT WHITE/BLACK
  PRINT TAB(25 - (N * 2)); "Rotor Display  ";  'CENTER THE DISPLAY

  FOR V9 = 1 TO N
    COLOR 0, 7                        'BLACK/BRIGHT WHITE
    PRINT USING " \\ "; RB$(V9);
    COLOR 7, 0
    PRINT " ";
  NEXT V9

  COLOR 0, 2                          'BLACK/GREEN
  PRINT USING " \\ "; R13$;           'REVERSING ROTOR
  COLOR 7, 0

  RETURN


TAB113:    '---------------------------- CHECKSUM ROUTINE

  CHECKSUM = CHECKSUM + CHECKSUM1
  CHECKSUM = CHECKSUM MOD 100
  IF CHECKSUM = 0 THEN CHECKSUM = 100
  PRINT "CHECKSUM = "; C$(CHECKSUM)
  RETURN


TAB115:  '---------------------------- SELECT CHARACTER SET ROTATIONAL VALUE

  CLS
  LOCATE 1, 10
  PRINT "      (See the current S.O.I for the values to use)"
  LOCATE 3, 10
  PRINT "        SET ROTATIONAL SHIFT VALUE FOR THE CHARACTER SET"
  LOCATE 5, 10
  PRINT "            USING ONE OF THE FOLLOWING PRIME NUMBERS"
  LOCATE 8, 5
  PRINT "0,1,3,7,11,13,17,19,23,29,31,37,41,";
  PRINT "43,47,53,59,61,67,71,73,79,83,89,97"
  PRINT

COLOR 14, 0

RETRY:
  LOCATE 11, 25
  INPUT "ROTATIONAL VALUE  :   ", RV

  FOR U5 = 1 TO 13                    'TEST FOR MATCHING ROTOR ROTATION VALUES
    IF S(U5) = RV THEN                'MATCH FOUND
      BEEP
      GOTO RETRY
      EXIT FOR
      END IF
  NEXT U5

  P2 = 0
  FOR PN = 0 TO 24
    IF P(PN) = RV THEN
      P2 = 1
      EXIT FOR
      END IF
  NEXT PN

  IF P2 = 0 THEN
    BEEP
    GOTO RETRY
    END IF
    CHECKSUM1 = CHECKSUM1 + RV

  RETURN


TAB118:   '---------------------------'PRINT ROTORS CONTENTS (OPTIONAL)
 
  S$ = MID$(P$, 1, 200): GOSUB TAB120
  GOSUB TAB124                        'PRINT PATH IN ROTOR
  S$ = MID$(R$, 1, 200): GOSUB TAB120
 
  LPRINT TAB(L); M10$; M10$
  LPRINT TAB(L); M10$; M10$
      
  RETURN

TAB120: '----------------------------- PRINT ROTOR CONTENTS (OPTIONAL)

  H = 1

  FOR P = 1 TO 200
    LPRINT MID$(S$, H, 2);
    H = H + 2
  NEXT P

  LPRINT " R"; RO$

  RETURN

TAB122:  '---------------------------- PRINT SUPERENCIPHERMENT INFO

  LPRINT J2$; " Super Enciphered = "; J$; "   (Count = "; C(R1);
  LPRINT "   Row "; J2$; " = ( ";
  FOR Z9 = 1 TO 7
    LPRINT F$(R1, Z9); " ";
  NEXT Z9
  LPRINT ")"
 
  RETURN


TAB124:   '--------------------------- PRINT PATH WITHIN A ROTOR

LPRINT CHR$(27) + "t" + "1";          'SELECT GRAPHIC CHARACTER SET
LPRINT CHR$(27); "6";                 'GRAPHIC CHARACTER SET 2

L5$ = CHR$(200): L6$ = CHR$(187): L7$ = CHR$(188): L8$ = CHR$(201)
L9$ = CHR$(205)

  L1 = 1                              'FROM
  FOR L4 = 1 TO 200 STEP 2
    IF M$ = MID$(P$, L1, 2) THEN EXIT FOR
    L1 = L1 + 2
  NEXT L4

  L2 = 1                              'TO
  FOR L4 = 1 TO 200 STEP 2
    IF M$ = MID$(R$, L2, 2) THEN EXIT FOR
    L2 = L2 + 2
  NEXT L4

  IF L1 = L2 THEN GOTO SKIP21
  IF Q$ = "1" THEN GOTO SKIP25

  N2 = N2 + 1                         'ROTOR COUNTER
  IF N2 = N + 1 THEN                  'REG ROTORS + REV ROTOR
    IF L1 > L2 THEN
      LPRINT TAB(L2 + 3); L5$; L5$;
      FOR L3 = 1 TO (L1 - L2 - 2)
        LPRINT L9$;
      NEXT L3
      LPRINT L6$; L6$
    END IF

    IF L1 < L2 THEN
      LPRINT TAB(L1 + 3); L8$; L8$;
      FOR L3 = 1 TO (L2 - L1 - 2)
        LPRINT L9$;
      NEXT L3
      LPRINT L7$; L7$
    END IF

    GOTO SKIP22

    END IF

SKIP25:

IF L1 > L2 THEN
  LPRINT TAB(L2 + 3); L8$; L8$;
  FOR L3 = 1 TO (L1 - L2 - 2)
    LPRINT L9$;
  NEXT L3
  LPRINT L7$; L7$
  END IF

IF L1 < L2 THEN
  LPRINT TAB(L1 + 3); L5$; L5$;
  FOR L3 = 1 TO (L2 - L1 - 2)
    LPRINT L9$;
  NEXT L3
  LPRINT L6$; L6$
  END IF


  GOTO SKIP22

SKIP21:

  LPRINT TAB(L1); M10$; M10$

SKIP22:

  RETURN


TAB126:   '--------------------------- PRINT PATH WITHIN A PLUGBOARD

  LPRINT CHR$(27) + "t" + "1";          'SELECT GRAPHIC CHARACTER SET
  LPRINT CHR$(27); "6";                 'GRAPHIC CHARACTER SET 2
  L5$ = CHR$(200): L6$ = CHR$(187): L7$ = CHR$(188): L8$ = CHR$(201)
  L9$ = CHR$(205)

  L1 = 1                              'FROM
  FOR L4 = 1 TO 200 STEP 2
    IF A$ = MID$(Z2$, L1, 2) THEN EXIT FOR
    L1 = L1 + 2
  NEXT L4

  L2 = 1                              'TO
  FOR L4 = 1 TO 200 STEP 2
    IF A$ = MID$(Z1$, L2, 2) THEN EXIT FOR
    L2 = L2 + 2
  NEXT L4

  IF L1 > L2 THEN
     L3$ = L8$                        '
     L4$ = L7$                        '
     
  ELSE
     L3$ = L5$                        '
     L4$ = L6$                        '
  END IF

  IF L1 > L2 THEN SWAP L1, L2         'ADJUST FROM & TO POINTS

  IF L1 = L2 THEN GOTO SKIP23

  LPRINT TAB(L1 + 3); L3$; L3$;       'PRINT THE PATH
  FOR L3 = 1 TO (L2 - L1 - 2)
    LPRINT L9$;                       '
  NEXT L3
  LPRINT L4$; L4$
  GOTO SKIP24

SKIP23:

  LPRINT TAB(L1 + 3); M10$; M10$

SKIP24:

  RETURN


